#include <windows.h>
#define MAX_PATHNAME_LEN 256
#define MAX_STRING_LEN 256
VOID DIALOG_FileSaveAs(VOID);

void main(int argc, char *argv[]) {
        OPENFILENAME saveas;
        CHAR szPath[MAX_PATHNAME_LEN];
        CHAR szDir[MAX_PATHNAME_LEN];
        CHAR szDefaultExt[4];
        CHAR szzFilter[2 * MAX_STRING_LEN + 100];
       
        LPSTR p = szzFilter;
        memset(szzFilter, 0x00, sizeof(szzFilter));

        lstrcpy(szDefaultExt, "yyy");

        strcat(p, "Text files");
        p += strlen(p) + 1;
        lstrcpy(p, "*.zzz");
        p += strlen(p) + 1;
        strcat(p, "All? files");
        p += strlen(p) + 1;
        lstrcpy(p, "*.yyy");
        p += strlen(p) + 1;
        strcat(p, "All? files2");
        p += strlen(p) + 1;
        lstrcpy(p, "*.xxx");
        p += strlen(p) + 1;
        *p = '\0';

        if (argc > 2) {
           if (argv[2][0] == '~') {
             szPath[0] = 0x00;
             saveas.lpstrFile         = szPath;
           } else {
             lstrcpy(szPath, argv[2]);
             saveas.lpstrFile         = szPath;
           }
        } else {
           szPath[0] = 0x00;
           saveas.lpstrFile         = NULL;
        }
 
        GetCurrentDirectory(sizeof(szDir), szDir);

        saveas.lStructSize       = sizeof(OPENFILENAME);
        saveas.hwndOwner         = NULL;
        saveas.hInstance         = NULL;
        saveas.lpstrFilter       = szzFilter;
        saveas.lpstrCustomFilter = 0;
        saveas.nMaxCustFilter    = 0;
        saveas.nFilterIndex      = 0;
        
        saveas.nMaxFile          = sizeof(szPath);
        saveas.lpstrFileTitle    = 0;
        saveas.nMaxFileTitle     = 0;
        saveas.lpstrTitle        = 0;
        saveas.Flags             = OFN_PATHMUSTEXIST + OFN_OVERWRITEPROMPT + OFN_HIDEREADONLY + OFN_NOVALIDATE + OFN_FILEMUSTEXIST;
        saveas.nFileOffset       = 0;
        saveas.nFileExtension    = 0;
        saveas.lpstrDefExt       = szDefaultExt;
        saveas.lCustData         = 0;
        saveas.lpfnHook          = 0;
        saveas.lpTemplateName    = 0;


        if (argc > 1) {
            if (argv[1][0] == '~') {
              szDir[0] = 0x00;
              saveas.lpstrInitialDir = szDir;
            } else {
              saveas.lpstrInitialDir = argv[1];
            }
        } else {
            saveas.lpstrInitialDir = NULL;
        }
        printf("InitDir = '%s', name='%s'\n", saveas.lpstrInitialDir, saveas.lpstrFile);

        if (GetSaveFileName(&saveas)) {
            printf("Filename returned = %s\n", saveas.lpstrFile);
        }

        saveas.lpstrFile = NULL;
        saveas.lpstrInitialDir = NULL;
        printf("InitDir = '%s', name='%s'\n", saveas.lpstrInitialDir, saveas.lpstrFile);
        if (GetSaveFileName(&saveas)) {
            printf("Filename returned = %s\n", saveas.lpstrFile);
        }
}

